#import <appkit/View.h>
#import <appkit/color.h>

@interface CompositeView:View
{
    id source, destination, result, customImage;
    NXRect sRect, dRect, rRect;
    int operator, sourcePicture;
    NXColor sourceColor, destColor, backgroundColor;

    // Outlets...
    id sourceColorWell;
    id destColorWell;
    id backColorWell;
    id sourcePictureMatrix;
}

-initFrame:(const NXRect *)rect;
-free;

// Target-action methods
-setSourcePicture:sender;
-setOperator:sender;
-changeCustomImage:sender;
-changeSourceColor:sender;
-changeDestColor:sender;
-changeBackgroundColor:sender;

// Outlet-setting methods (we need these to set the initial colors)
- setSourceColorWell:anObject;
- setDestColorWell:anObject;
- setBackColorWell:anObject;

// These methods change the colors and display
- (void)changeSourceColorTo:(NXColor)color andDisplay:(BOOL)flag;
- (void)changeDestColorTo:(NXColor)color andDisplay:(BOOL)flag;
- (void)changeBackgroundColorTo:(NXColor)color andDisplay:(BOOL)flag;
- (BOOL)changeCustomImageTo:newImage;

// Other methods (some internal)
-drawSource:image;
-drawDestination:image;
-drawResult:image;
-drawSelf:(NXRect *)r :(int)count;
-speedyDraw;
-(int)operator;

- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- draggingExited:sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;
- (void)doColorDrag:(id <NXDraggingInfo>)sender;

@end



